#include <bits/stdc++.h>
using namespace std;

const int N=1e5+10;
typedef long long ll;
const ll inf=1e18;

int a[N];
ll dp[N], f[N], sol;
ll leftCost[N], rightCost[N], cost[N];
int n, firstLeft[N], firstRight[N];

ll first_subtask ()
{
    ll ret=0;
    for (int i=1;i<=n;i++) f[i]=dp[i]=-inf;

    for (int i=1;i<=n;i++)
    {
        ll middle=0;
        for (int j=i-1;j>=0;j--)
        {
            if (a[j]>a[i]) middle+=cost[j];
            if (a[j]<a[i]) dp[i]=max(dp[i], dp[j]+leftCost[i]-middle);
        }
        //cout << dp[i] << " ";
    }
    //cout << endl;
    for (int i=1;i<=n;i++) dp[i]=max(dp[i], dp[i-1]);

    for (int i=n;i>=1;i--)
    {
        ll middle=0;
        for (int j=i+1;j<=n+1;j++)
        {
            if (a[j]>a[i]) middle+=cost[j];
            if (a[j]<a[i]) f[i]=max(f[i], f[j]-middle+rightCost[i]);
        }
    }
    for (int i=n;i>=1;i--) f[i]=max(f[i+1], f[i]);
    for (int i=1;i<=n;i++) ret=max(ret, dp[i]+f[i]);

    return ret;
}

ll third_subtask ()
{
    ll ret=0;

    stack<int> box;
    for (int i=1;i<=n;i++) firstLeft[i]=firstRight[i]=0;
    for (int i=1;i<=n;i++)
    {
        while (!box.empty() && a[box.top()]>a[i]) box.pop();
        if (!box.empty()) firstLeft[i]=box.top();
        box.push(i);
    }
    while (!box.empty()) box.pop();
    for (int i=n;i>=1;i--)
    {
        while (!box.empty() && a[box.top()]>a[i]) box.pop();
        if (!box.empty()) firstRight[i]=box.top();
        box.push(i);
    }

    for (int i=1;i<=n;i++) dp[i]=dp[firstLeft[i]]+leftCost[i];
    for (int i=n;i>=1;i--) f[i]=f[firstRight[i]]+rightCost[i];
    for (int i=1;i<=n;i++) dp[i]=max(dp[i-1], dp[i]);
    for (int i=n;i>=1;i--) f[i]=max(f[i+1], f[i]);
    for (int i=1;i<=n;i++) ret=max(ret, dp[i]+f[i]);
    return ret;
}

int main()
{
    scanf ("%d", &n);
    for (int i=1;i<=n;i++) scanf ("%d %lld %lld %lld", &a[i], &cost[i], &leftCost[i], &rightCost[i]);

    if (n<=1000) cout << first_subtask();
    else cout << third_subtask();

    return 0;
}