#include <cstdio>
#include <cstdlib>
#include <map>
#include <algorithm>
#include <vector>
#include <list>

using namespace std;

typedef int64_t i64;

int N;

vector <int> h;
vector <int> x, l, r;

void pz2() {
    int mh = -1;
    i64 zarada = 0;
    for (int i = 0; i < N; i++) {
        if (h[i] >= mh) {
            zarada += l[i];
            mh = h[i];
        }
    }
    mh = -1;
    for (int i = N-1; i >= 0; i--) {
        if (h[i] >= mh) {
            zarada += r[i];
            mh = h[i];
        }
    }

    printf("%lld", zarada);
}

int main()
{
    scanf("%d", &N);
    h = x = l = r = vector<int>(N);
    for (int i = 0; i < N; i++) {
        scanf("%d%d%d%d",&h[i],&x[i],&l[i],&r[i]);
    }

    pz2();

    return 0;
}

/*
6
3 1000000 5 5
5 1000000 5 5
4 1000000 5 5
7 1000000 5 5
3 1000000 5 5
1 1000000 5 5
*/