#include <bits/stdc++.h>
using namespace std;
const int MAXN = 100010;
int h[MAXN], l[MAXN], r[MAXN], c[MAXN];
long long dpl[MAXN], dpr[MAXN];
long long cumc[MAXN];
map<int,int> idx;
int n;
void compress()
{
    vector<int> vals;
    for(int i = 1; i <= n; i++)
        vals.push_back(h[i]);
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end())-vals.begin());
    for(int i = 1; i <= vals.size(); i++)
        idx[vals[i - 1]] = i;
    for(int i = 1; i <= n; i++) h[i] = idx[h[i]];
}
long long bit[MAXN];
void upd(int pos, long long val)
{
    while(pos <= n)
    {
        bit[pos] = max(bit[pos], val);
        pos += (pos&-pos);
    }
}
long long get(int pos)
{
    long long ret = 0;
    while(pos)
    {
        ret = max(ret, bit[pos]);
        pos -= pos & -pos;
    }
    return ret;
}
void clr()
{
    for(int i = 0; i <= n; i++)
        bit[i] = 0;
}
int maxl[MAXN], maxr[MAXN];
void subtask2()
{
    for(int i = 1; i <= n; i++)
        maxl[i] = max(maxl[i - 1], h[i]);
    for(int i = n; i >= 1; i --)
        maxr[i] = max(maxr[i + 1], h[i]);
    int ans = 0;
    for(int i = 1; i <= n; i++)
    {
        if(h[i] >= maxl[i]) ans += l[i];
        if(h[i] >= maxr[i]) ans += r[i];
    }
    printf("%d\n", ans);
    return;
}
void subtask3()
{
    for(int i = 1; i <= n; i++)
    {
        dpl[i] = l[i] + get(h[i]);
        upd(h[i], dpl[i]);
        //printf("%d ", dpl[i]);
    }
    clr();
    //printf("\n");
    for(int i = n; i >= 1; i--)
    {
        dpr[i] = r[i] + get(h[i]);
        upd(h[i], dpr[i]);
        //printf("%d ", dpr[i]);
    }
    long long ans = 0;
    for(int i = 1; i <= n; i++)
        ans = max(ans, dpl[i] + dpr[i]);
    cout << ans << endl;
    return;
}
int main()
{
    scanf("%d", &n);
    long long sumc = 0;
    for(int i = 1; i <= n; i++)
    {
        scanf("%d %d %d %d",&h[i],&c[i],&l[i],&r[i]);
        sumc += c[i];
    }
    compress();
    //cout << "LALA" << endl;
    if(sumc == 0) subtask3();
    else subtask2();
}
/*
3
1 0 1 30
100 0 3 1
50 0 10 5
*/
/*
8
1771 25 14 13
1270 21 24 16
1018 19 23 24
1729 26 25 16
1817 18 26 22
1861 26 13 18
1541 19 20 23
1645 25 14 17
*/
/*
10
1041 18 23 7
1169 29 16 29
1962 14 23 23
1281 27 29 28
1995 21 29 26
1391 14 22 13
1815 19 26 29
1718 18 20 13
1771 25 29 18
1837 15 14 26
*/