#include <bits/stdc++.h>
#define mid (left+right)/2
using namespace std;

const int N=1e5+10;
typedef long long ll;
const ll inf=1e18;

int a[N];
ll dp[N], f[N], sol;
ll leftCost[N], rightCost[N], cost[N];
int n;
vector<pair<int, int> > vx;

ll first_subtask ()
{
    ll ret=0;
    for (int i=1;i<=n;i++) f[i]=dp[i]=-inf;

    for (int i=1;i<=n;i++)
    {
        ll middle=0;
        for (int j=i-1;j>=0;j--)
        {
            if (a[j]>a[i]) middle+=cost[j];
            if (a[j]<a[i]) dp[i]=max(dp[i], dp[j]+leftCost[i]-middle);
        }
        //cout << dp[i] << " ";
    }
    //cout << endl;
    for (int i=1;i<=n;i++) dp[i]=max(dp[i], dp[i-1]);

    for (int i=n;i>=1;i--)
    {
        ll middle=0;
        for (int j=i+1;j<=n+1;j++)
        {
            if (a[j]>a[i]) middle+=cost[j];
            if (a[j]<a[i]) f[i]=max(f[i], f[j]-middle+rightCost[i]);
        }
    }
    for (int i=n;i>=1;i--) f[i]=max(f[i+1], f[i]);
    for (int i=1;i<=n;i++) ret=max(ret, dp[i]+f[i]);

    return ret;
}

void compress ()
{
    int k=0, last=-1;
    sort (vx.begin(), vx.end());
    for (auto xt: vx)
    {
        if (xt.first!=last) k++;
        a[xt.second]=k;
        last=xt.first;
    }
}

ll st[4*N];

void update (int idx, int left, int right, int x, ll val)
{
    if (left==right)
    {
        st[idx]=max(st[idx], val);
        return;
    }

    if (x<=mid) update (2*idx, left, mid, x, val);
    else update (2*idx+1, mid+1, right, x, val);
    st[idx]=max(st[2*idx], st[2*idx+1]);
}

ll query (int idx, int left, int right, int l, int r)
{
    if (l<=left && right<=r) return st[idx];

    ll ret=0;
    if (l<=mid) ret=max(ret, query(2*idx, left, mid, l, r));
    if (r>mid) ret=max(ret, query(2*idx+1, mid+1, right, l, r));
    return ret;
}

ll third_subtask ()
{
    compress();
    ll ret=0;

    for (int i=1;i<=n;i++)
    {
        dp[i]=max(dp[i], query(1, 1, n, 1, a[i])+leftCost[i]);
        update(1, 1, n, a[i], dp[i]);
    }

    memset (st, 0, sizeof st);

    for (int i=n;i>=1;i--)
    {
        f[i]=max(f[i], query(1, 1, n, 1, a[i])+rightCost[i]);
        update (1, 1, n, a[i], f[i]);
    }

    for (int i=1;i<=n;i++) dp[i]=max(dp[i-1], dp[i]);
    for (int i=n;i>=1;i--) f[i]=max(f[i+1], f[i]);
    for (int i=1;i<=n;i++) ret=max(ret, dp[i]+f[i]);
    return ret;
}

int main()
{
    scanf ("%d", &n);
    for (int i=1;i<=n;i++)
    {
        scanf ("%d %lld %lld %lld", &a[i], &cost[i], &leftCost[i], &rightCost[i]);
        vx.push_back({a[i], i});
    }

    if (n<=1000) cout << first_subtask();
    else cout << third_subtask();

//    cout << endl;
//    third_subtask();

    return 0;
}