#include <bits/stdc++.h>
using namespace std;

const long long inf = 1000000000000;
struct ls
{
    long long sol, rus;
    ls()
    {
        sol = -inf;
        rus = 0;
    }
    ls(long long dp, long long rus1)
    {
        sol = dp;
        rus = rus1;
    }
};
ls operator + (const ls & a, const ls & b)
{
    ls c;
    c.sol = max(a.sol-b.rus,b.sol);
    c.rus = a.rus+b.rus;
    return c;
}

const  int N = (1<<17);

ls segml[2*N+20];

void addl(int p,ls v)
{
    int x = N+p;
    segml[x] = v;
    x/=2;
    while(x)
    {
        segml[x] = segml[2*x]+segml[2*x+1];
        x/=2;
    }
}

ls get(int l, int r, int a, int b, int v)
{
    if (l > b || r < a)
        return ls();
    if (l >= a && r <= b)
        return segml[v];
    return get(l,(l+r)/2,a,b,2*v)+get((l+r)/2+1,r,a,b,2*v+1);
}

struct data
{
    long long vis,zarl,zard,rus;
    int ind;
    long long rusiVise;
} a[100010];

map<long long,int> cmpr;
int n;

long long dpl[100010],dpr[100010];

int main()
{
    scanf("%d",&n);
    for(int i = 0; i < n ; i++)
    {
        scanf("%lld %lld %lld %lld",&a[i].vis,&a[i].rus,&a[i].zarl,&a[i].zard);
        cmpr[a[i].vis] = 0;
    }
    int w = 1;
    for(auto &p : cmpr)
        p.second = w++;
    for(int i = 0; i < n; i++)
        a[i].ind = cmpr[a[i].vis];
    vector<pair<int,int>> red;
    for(int i = 0; i < n; i++)
        red.push_back({a[i].ind,i});
    sort(red.begin(),red.end());
    long long sum = 0;
    for(int i = red.size()-1; i >= 0; i--)
    {
        a[red[i].second].rusiVise = sum;
        sum += a[red[i].second].rus;
    }

    for(int i = 0; i < 2*N+5; i++)
        segml[i] = ls();
    addl(0,ls(0,0));
    for(int i = 0; i < n; i++)
    {
        long long tmp = get(0,N-1,0,a[i].ind-1,1).sol;
        tmp += a[i].zarl;
        dpl[i] = tmp;
        addl(a[i].ind,ls(tmp,a[i].rus));
    }
    for(int i = 0; i < 2*N+5; i++)
        segml[i] = ls();
    addl(0,ls(0,0));
    for(int i = n-1; i >= 0; i--)
    {
        long long tmp = get(0,N-1,0,a[i].ind-1,1).sol;
        tmp += a[i].zard;
        dpr[i] = tmp;
        addl(a[i].ind,ls(tmp,a[i].rus));
    }
    long long sol = 0;
    for(int i = 0; i < n; i++)
    {
        long long tmp = dpl[i]+dpr[i]-a[i].rusiVise;
        sol = max(sol,tmp);
    }
    printf("%lld\n",sol);
}

/*
10
1041 18 23 27
1169 29 16 29
1962 14 23 23
1281 27 29 28
1995 21 29 26
1391 14 22 13
1815 19 26 29
1718 18 20 13
1771 25 29 18
1837 15 14 26

10
1 18 23 27
2 29 16 29
9 14 23 23
3 27 29 28
10 21 29 26
4 14 22 13
7 19 26 29
5 18 20 13
6 25 29 18
8 15 14 26

*/